/***********************************************************************/
/*                                                                     */
/*                               Pio (C)                               */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2011-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Bruno Verlyck <Bruno.Verlyck@inria.fr>                             */
/*                                                                     */
/***********************************************************************/

#ifndef VALUE_TYPE_DEF_INCLUDED
#define VALUE_TYPE_DEF_INCLUDED

typedef enum {
  VTD_Bool_type,
  VTD_String_type,
  VTD_Int_type,
  VTD_Native_Int_type,
  VTD_Int32_type,
  VTD_Int64_type,
  VTD_Float_type,
  VTD_Float_bin_type,
  VTD_Couple_Bool_type,
  VTD_Couple_Int_type,
  VTD_Couple_Native_Int_type,
  VTD_Couple_Int32_type,
  VTD_Couple_Int64_type,
  VTD_Couple_Float_type,
  VTD_Couple_Float_bin_type,
  VTD_Triple_Bool_type,
  VTD_Triple_Int_type,
  VTD_Triple_Native_Int_type,
  VTD_Triple_Int32_type,
  VTD_Triple_Int64_type,
  VTD_Triple_Float_type,
  VTD_Triple_Float_bin_type,
} vtd_scalar_type;

#define VTD_SCALAR_TYPE 0x100
#define VTD_VECTOR_TYPE 0x200
#define VTD_MATRIX_TYPE 0x400
#define VTD_SCALAR_MASK 0xFF
#define VTD_TYPE_MASK	(~VTD_SCALAR_MASK)

typedef unsigned int vtd_value_type;

#define vtd_scalar_type_of_value_type(vt) ((vtd_scalar_type) ((vt) & VTD_SCALAR_MASK))
vtd_scalar_type make_couple_type (vtd_scalar_type fst, vtd_scalar_type snd);
vtd_scalar_type make_triple_type (vtd_scalar_type fst, vtd_scalar_type snd, vtd_scalar_type thrd);
int vtd_check_value_type (vtd_value_type vt);

#define	       vtd_scalar_type(typ) ((vtd_scalar_type) (((int) typ) | VTD_SCALAR_TYPE))
#define	       vtd_vector_type(typ) ((vtd_scalar_type) (((int) typ) | VTD_VECTOR_TYPE))
vtd_value_type vtd_matrix_type (vtd_scalar_type typ);

#endif
