(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_universe.mli,v 1.5 2014/05/06 12:56:19 fclement Exp $*)

(** {3 Numbering matrix slots} *)

type size = Umatrix_hashtbl.size;;
type element = Umatrix_hashtbl.key;; (* = Unatural.t * Unatural.t *)
type index = Umatrix_hashtbl.value;; (* = element Uindex.t *)

type t = private
  {
   tables : Umatrix_hashtbl.t;
   cardinal : Upervasives.length;
  }
;;
(** A universe is the support of a family of sets. It is a set that
  contains all the elements that belong to a set of the family of sets.
  In short, any set we consider in this library is a subset of some universe.
*)

(** {6 Construction function} *)

val make : size -> t;;

(** {6 Access functions} *)

val cardinal : t -> Upervasives.length;;
val size : t -> size;;

val index : t -> element -> index;;

val element : t -> index -> element;;
val sub_elements : t -> index array -> element array;;
