(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: display_window.mli,v 1.9 2014/05/06 12:56:21 fclement Exp $ *)

open Refinement_types;;
open Display_types;;

(** {6 Setting the display window} *)

val margin : length;;

val window_setup :
  dimension -> graphics_mode ->
  min_window_size -> max_window_size -> image_size -> unit
;;

val get_graphics_elements : unit -> graphics_elements;;

(**/**)
(** {6 Undocumented functions, for testing purposes} *)

val aspect : image_size -> aspect;;

val comps_direction : image_size -> comps_direction;;

val same_direction : direction -> comps_direction -> bool;;

val coeffs :
  dimension -> graphics_mode -> direction -> comps_direction ->
  Unatural.t
;;

val compound_length :
  dimension -> graphics_mode -> direction -> comps_direction ->
  length -> length -> length
;;

val split_ratio :
  dimension -> graphics_mode -> direction -> comps_direction ->
  length -> length -> length -> Upositive_rational.t
;;

val scaling_factor :
  dimension -> graphics_mode ->
  min_window_size -> max_window_size -> image_size -> scaling_factor
;;

val set_graphics_elements :
  dimension -> graphics_mode ->
  min_window_size -> max_window_size -> image_size -> unit
;;
