(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: wrapper.mli,v 1.10 2014/05/06 12:56:22 fclement Exp $ *)

open Pio;;
open Wire_types;;

val make_init_wrapper :
  pf -> Upervasives.function_name ->
  (dimension, size * partition * coarse_parameter * cost) task_wrapper
;;

val make_grad_wrapper :
  pf -> Upervasives.function_name ->
  (fine_parameter, fine_gradient) task_wrapper
;;

val make_optim_wrapper :
  pf -> Upervasives.function_name ->
  (partition * coarse_parameter, coarse_parameter * cost) task_wrapper
;;

val make_final_wrapper :
  pf -> Upervasives.function_name ->
  (fine_parameter, unit) task_wrapper
;;
